//DefinitionenAufloesen_502d.js
// 18.10.16 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:GREP-Stile usw. auflsen

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

// eine Referenz zum vordersten Dokument
var curDoc = app.documents[0];

// die Sperrung der Ebenen speichern und aufheben (falls notwendig)
var allLayers = curDoc.layers;
var nLayers = allLayers.length;
var layerLocks = new Array ();
for (var i=0; i<nLayers; i++) {
	if (allLayers[i].locked == true) {
		allLayers[i].locked = false;
		layerLocks.push(true);
	}
	else {
		layerLocks.push(false);
	}
}

// die Sperrung der Rahmen aufheben
curDoc.pageItems.everyItem().locked = false;

// der Name des Zeichenformats "Kein"
try {
	var noCharName  = curDoc.characterStyles[0].name;
}
catch (e) {
}

// die vorhandenen Stories
var allStories = curDoc.stories;
var nStories   = allStories.length;

// die *benutzten* Absatz- und Zeichenformate auflisten
allParaStyles = new Array();
allNestStyles = new Array();
for (var s=0; s<nStories; s++) {
	var allParas = allStories[s].paragraphs;
	var nParas   = allParas.length;
	for (var p=0; p<nParas; p++) {
		var curStyle = allParas[p].appliedParagraphStyle;
		var notInArr = checkStyle(curStyle);
		if (notInArr) {
			allParaStyles.push(curStyle);
			// die verschachtelten Zeichenformate auflisten
			var nNested = curStyle.nestedStyles.length;
			if (nNested > 0) {
				for (n=0; n<nNested; n++) {
					try {
						var curNest = curStyle.nestedStyles[n].appliedCharacterStyle;
						var notInArr = checkStyle(curNest);
						if (notInArr) {
							allNestStyles.push(curNest);
						}
					}
					catch (e) {
					}
				}
			}
		}
	}
}

// die Anzahl Absatzformate
var nParaStyles = allParaStyles.length;

// die Anzahl Zeichenformate
var nCharStyles = allNestStyles.length;

// eine temporre Farbe bestimmen
var tmpCol = curDoc.colors.itemByName("Magenta");

// die Grep-Vorgaben zurcksetzen
app.findGrepPreferences = app.changeGrepPreferences = null;
// Musterseiten bercksichtigen
app.findChangeGrepOptions.includeMasterPages = true;
// die Text-Vorgaben zurcksetzen
app.findTextPreferences = app.changeTextPreferences = null;
// Musterseiten bercksichtigen
app.findChangeTextOptions.includeMasterPages = true;

// den GREP-Stilen die Zeichenformate zuweisen
for (p=0; p<nParaStyles; p++) {
	var allGrepStyles = allParaStyles[p].nestedGrepStyles;
	var nGrepStyles   = allGrepStyles.length;
	for (n=0; n<nGrepStyles; n++) {
		var curGrep = allGrepStyles[n].grepExpression;
		var curParaStyle  = allParaStyles[p];
		var curCharStyle  = allGrepStyles[n].appliedCharacterStyle;
		app.findGrepPreferences.appliedParagraphStyle = curParaStyle;
		app.findGrepPreferences.appliedCharacterStyle = null;
		app.changeGrepPreferences.appliedCharacterStyle = curCharStyle;
		app.findGrepPreferences.findWhat = curGrep;
		app.changeGrepPreferences.changeTo = "";
		var founds  = curDoc.findGrep();
		var nFounds = founds.length;
		if (nFounds != 0) {
			var doChange = true;
			for (f=0; f<nFounds; f++) {
				var curStory = founds[f].parent;
				var curCont  = founds[f].contents;
				var nChars   = curCont.length;
				var curPos   = founds[f].index;
				for (var c=curPos; c<curPos+nChars; c++) {
					if (curStory.characters[c].appliedCharacterStyle.name != noCharName) {
						doChange = false;
						break;
					}
				}
				if (doChange == false) {
					continue;
				}
			} 
			if (doChange) {
				try {
					curDoc.changeGrep();
				}
				catch (e) {
				}
			}
		}
	}
}

// den Suchvorgaben die temporre Farbe zuweisen
app.findTextPreferences.underlineGapColor = tmpCol;

// bei Verschachtelungen die Zeichenformate zuweisen
for (var c=0; c<nCharStyles; c++) {
	var curStyle = allNestStyles[c];
	app.changeTextPreferences.appliedCharacterStyle = curStyle;
	var savedColor = curStyle.underlineGapColor;
	var finds = undefined;
	var findsLength = 0;
	do {
		if (finds) {findsLength = finds.length}
		curStyle.underlineGapColor = tmpCol;
		finds = curDoc.changeText();
	} while (findsLength != finds.length);
	curStyle.underlineGapColor = savedColor;
}

// Nummerierungen und Aufzhlungen in Text konvertieren
for (var s=0; s<nStories; s++) {
	try {
		allStories[s].paragraphs.everyItem().convertBulletsAndNumberingToText();
	}
	catch (e) {
	}
	// die Tabellen auch behandeln
	try {
		allStories[s].tables.everyItem().cells.everyItem().texts[0].convertBulletsAndNumberingToText();
	}
	catch (e) {
	}
}

// die GREP-Stile, Aufzhlungen, Nummerierungen und Verschachtelungen entfernen
for (p=0; p<nParaStyles; p++) {
	var allGrepStyles = allParaStyles[p].nestedGrepStyles;
	var nGrepStyles   = allGrepStyles.length;
	for (s=nGrepStyles-1; s>-1; s--) {
		try {
			allParaStyles[p].nestedGrepStyles[s].remove();
		}
		catch (e) {
		}
	}
	try {
		allParaStyles[p].bulletsAndNumberingListType = 1280601711;
	}
	catch (e) {
	}
	var allStyles = allParaStyles[p].nestedStyles;
	var nStyles   = allStyles.length;
	for (s=nStyles-1; s>-1; s--) {
		try {
			allParaStyles[p].nestedStyles[s].remove();
		}
		catch (e) {
		}
	}
}

// die Grep-Vorgaben zurcksetzen
app.findGrepPreferences = app.changeGrepPreferences = null;
// die Text-Vorgaben zurcksetzen
app.findTextPreferences = app.changeTextPreferences = null;

// die Sperrung der Ebenen wiederherstellen (falls notwendig)
for (var i=0; i<(nLayers); i++) {
	allLayers[i].locked = layerLocks[i];
}

// das Ende der Aktion verknden
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Fertig.");
dlog.show();
$.sleep(999);
dlog.close();


///////////////////////////////////////////////////////////////////////////////////////////////////
// die Funktion, welche prft, ob ein Absatzformat schon bekannt ist
function checkStyle(curStyle) {
	var nStyles = allParaStyles.length;
	for (var n=0; n<nStyles; n++) {
		if (allParaStyles[n] == curStyle) {
			return false;
		}
	}
	return true;
}

// die Funktion, welche prft, ob ein Zeichenformat schon bekannt ist
function checkStyle(curStyle) {
	var nStyles = allNestStyles.length;
	for (var n=0; n<nStyles; n++) {
		if (allNestStyles[n] == curStyle) {
			return false;
		}
	}
	return true;
}